function [mx, my, u]=pri_dual2(rho0,rho1,mu,dx)
%% Initialization
M=size(rho0,1);
mx=zeros(M+1, M); my=zeros(M, M+1); phi=zeros(M, M);
u = rho0;
tol = M*1e-5;
%tol = 1e-3;
maxit = 5e6;

fprintf('%8s%8s\n', 'Iter','Feas');
for k = 1:maxit
    %% Update mx, my
    newmx=zeros(M+1, M);
    newmy=zeros(M, M+1);
    i = 2:M;
    
    [newmx(i,i), newmy(i,i)]=shrink2(mx(i,i)+mu*(phi(i,i)-phi(i-1,i))/dx, ... 
        my(i,i)+mu*(phi(i,i)-phi(i,i-1))/dx, mu);

  
    % Boundary conditions
    
    newmx(i,1)=shrink(mx(i,1) + mu*(phi(i,1)-phi(i-1,1))/dx, mu);
    newmy(1,i)=shrink(my(1,i) + mu*(phi(1,i)-phi(1,i-1))/dx, mu);
    %% Update u
    newu = u - mu*phi;
    newu = min(max(newu, 0), rho1);

    
    
    
    %% Update phi
    a=1:M;
    b=1:M;
    newphi = phi+mu*(-rho0 + ...
        2*((newmx(a+1,b)-newmx(a,b)+newmy(a,b+1)-newmy(a,b))/dx + newu)-...
        ((mx(a+1,b)-mx(a,b)+my(a,b+1)-my(a,b))/dx + u));
    
    
    %diff = sum(sum((rho0-u)))
    
    
    mx = newmx; my = newmy;
    phi = newphi; u = newu;
    
    %W1=Was(mx,my);
    %[W1 cons(mx,my,rho0, u, dx) phi(1,1)];
    constr = cons(mx,my,rho0, u, dx);    
    fprintf('%8d%8.4f\n', k, constr);
    if constr < tol
        display(k)
        break;
    end
    
    
    
end

    function z = shrink(x,r)
        z = max(0,x - r) - max(0,-x - r);
    end

    function [w,z] = shrink2(x,y,r)
        l2 = sqrt(x.^2+y.^2);
        t = (l2>r).*(1 - r./(l2+eps));
        w = t.*x;
        z = t.*y;          
    end
end
